import gurobi.*;
import java.util.stream.*;

public class Max_independent_set {
    public static void main(String[] args) throws Exception {
        int edges[][]={{0, 1},{2,3},{0,4},{3,1},{3,4}};
        int nVertexes = 5;

        // Create new environment.
        GRBEnv env = new GRBEnv();

        // Create empty optimization model.
        GRBModel model = new GRBModel(env);

        // Create variables x.
        // addVar(lowerBound, upperBound, objectiveCoeff, variableType, name)
        GRBVar[] x = new GRBVar[nVertexes];
        for (int i = 0; i < nVertexes; i++){
            x[i] =  model.addVar(0.0, 1.0, 0.0, GRB.INTEGER, "vertex" + i);
        }

        // Integrate new variables into model.
        model.update();

        // Add constraints:
        // addConstr(leftHandSide, inequalityType, rightHandSide, name)
	
	for (int i = 0; i < edges.length; i++) {
	    GRBLinExpr cons = new GRBLinExpr();
            cons.addTerm(1.0, x[edges[i][0]]);
	    cons.addTerm(1.0, x[edges[i][1]]);
	    model.addConstr(cons, GRB.LESS_EQUAL, 1, "cons" + i);
        }
	
	GRBLinExpr obj = new GRBLinExpr();
	double[] coeffs = new double [nVertexes];
        for (int i = 0; i < nVertexes; i++) {
            coeffs[i] = 1.0;
        }

        obj.addTerms(coeffs, x);
        model.setObjective(obj, GRB.MAXIMIZE);

        // Solve the model.
        model.optimize();

        // Print the objective
        // and the values of the decision variables in the solution.
        for (int i = 0; i < nVertexes; i++){
            System.out.println(x[i].get(GRB.StringAttr.VarName)+ " " + x[i].get(GRB.DoubleAttr.X));
        }
    }
}
